;  HELP ENGINE PARA GWADA
;
;  Mdulo MOUSE.ASM
;  Rotinas de tratamento de mouse
;
;  Trabalho de conclusao
;  Bacharelado em Informatica
;
;  Ulrich Peters
;

.MODEL COMPACT

extrn _mouse_x	; posiao horizontal do mouse
extrn _mouse_y	; posiao vertical do mouse
extrn _buttons	; estado dos botoes

.DATA

.STACK

.CODE
PUBLIC _mouse_reset
PUBLIC _mouse_enable
PUBLIC _mouse_disable
PUBLIC _mouse_read

;===========================================
; int mouse_reset(void)
; retorna -1, caso mouse presente
;          0, caso mouse ausente
; ==========================================
_mouse_reset proc
		mov ax,0
		int 33h
		ret
_mouse_reset endp

; ===================================================
; void mouse_enable(void)
; habilita a representaao do cursor do mouse na tela
; ===================================================
_mouse_enable proc
		mov ax,1
		int 33h
		ret
_mouse_enable endp

; ===================================
; void mouse_disable(void)
; desabilita a representaao do mouse
; ===================================
_mouse_disable proc
		mov ax,2
		int 33h
		ret
_mouse_disable endp

; =====================================================
; void mouse_read(void)
; le o mouse e atualiza as variveis de estado do mouse
; =====================================================
_mouse_read proc
		mov ax,3
		int 33h
		mov _buttons,bx
		mov _mouse_x,cx
		mov _mouse_y,dx
		ret
_mouse_read endp

END